<?php

echo '<p><b>Mise à jour de la base de données <i class="fas fa-angle-double-right"></i> Version 0.50</b></p>
<ul class="maxwidth">';

// Gestion du créneau par défaut pour réservation à distance
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_reseleve_creneau'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_reseleve_creneau', '1', 'Gestion du créneau par défaut pour réservation à distance.')");
}
echo '<li>Gestion du créneau par défaut pour réservation à distance.</li>';

// Gestion du créneau par défaut pour réservation à distance
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_reseleve_cgtmdp'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_reseleve_cgtmdp', '0', 'Autorisation de changement de mot de passe pour les usagers (0 par défaut).')");
}
echo '<li>Autorisation de changement de mot de passe pour les usagers (0 par défaut).</li>';

$ouverture = opendir("./db/proc/");
$lecture = readdir($ouverture);
unlink ("./db/proc/multi_res_opt.php");
closedir($ouverture);
echo '<li>Suppression d\'un fichier obsolète d\'accès en réservation</li>';

$ouverture = opendir("./db/");
$lecture = readdir($ouverture);
unlink ("./db/install_compte.php");
closedir($ouverture);
echo '<li>Suppression d\'un fichier obsolète de création de compte</li>';

function rand_nb($length = 8) {
    $characters = '123456789';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}
	
$eleves = mysqli_query($bdd,"SELECT * FROM ".$prefix."_eleves");
$checknb=0;
foreach($eleves as $eleve) {
	if($eleve['id_perso']=='reserver') {
		$ident = $eleve['id_perso'].rand_nb(2);
		mysqli_query($bdd,"UPDATE ".$prefix."_eleves SET id_perso = '".strtolower($ident)."' WHERE eleves_id = '".$eleve['eleves_id']."'");
		$checknb++;
	}
	if($eleve['id_constr']=='reserver') {
		$ident = $eleve['id_constr'].rand_nb(2);
		mysqli_query($bdd,"UPDATE ".$prefix."_eleves SET id_constr = '".strtolower($ident)."' WHERE eleves_id = '".$eleve['eleves_id']."'");
		$checknb++;
	}
}
echo '<li>Modification d\'éventuels élèves dont un login serait "reserver" ('.$checknb.')</li>';

$users = mysqli_query($bdd,"SELECT * FROM ".$prefix."_user");
$checknb=0;
foreach($users as $user) {
	if($user['login']=='reserver') {
		$ident = $user['login'].rand_nb(2);
		mysqli_query($bdd,"UPDATE ".$prefix."_user SET login = '".strtolower($ident)."' WHERE id = '".$user['id']."'");
		$checknb++;
	}
}
echo '<li>Modification d\'éventuels utilisateurs dont le login serait "reserver" ('.$checknb.')</li>';

// Ajout d'une colonne sel dans la table ".$prefix."_user
mysqli_query($bdd,"ALTER TABLE ".$prefix."_user ADD sel VARCHAR ( 200 ) DEFAULT 'NULL'");
mysqli_query($bdd,"UPDATE ".$prefix."_user SET sel = '0'");
echo '<li>Ajout d\'une colonne sel dans la table _user, avec valeur 0</li>';

// Ajout d'une colonne sel dans la table ".$prefix."_elevesmaj
mysqli_query($bdd,"ALTER TABLE ".$prefix."_elevesmaj ADD sel VARCHAR ( 200 ) DEFAULT 'NULL'");
echo '<li>Ajout d\'une colonne sel dans la table _elevesmaj</li>';

// Ajout d'une colonne sel dans la table ".$prefix."_eleves
mysqli_query($bdd,"ALTER TABLE ".$prefix."_eleves ADD sel VARCHAR ( 200 ) DEFAULT 'NULL'");
mysqli_query($bdd,"UPDATE ".$prefix."_eleves SET sel = '0'");
echo '<li>Ajout d\'une colonne sel dans la table _eleves, avec valeur 0</li>';

// Ajout d'un sel pour le mot de passe générique de réservation
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_reseleve_mdpsel'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_reseleve_mdpsel', '0', 'Sel pour le mot de passe générique de réservation.')");
}
echo '<li>Ajout d\'un sel pour le mot de passe générique de réservation</li>';

// version bdd :
mysqli_query($bdd,"UPDATE ".$prefix."_parametres SET valeur = '0.50' WHERE param_nom = 'version_bdd'");
echo '<li>Mise à jour de la base de données effectuée - version_bdd 0.50.</li></ul>';
?>